#include <bits/stdc++.h>
#define ll long long
#define MAXN 200010
using namespace std;
ll a[MAXN],b[MAXN];
int main()
{
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    for (ll i=1;i<=n;i++)
        cin >> a[i];
    for (ll i=1;i<=n;i++)
        cin >> b[i];
    if (n<=2000)
    {
        ll ans=0;
        for (ll i=1;i<=n;i++)
        {
            ans=max(ans,a[i]*b[i]);
            ll xorr=a[i],andd=b[i];
            for (ll j=i+1;j<=n;j++)
            {
                xorr^=a[j];
                andd&=b[j];
                ans=max(ans,xorr*andd);
            }
        }
        cout << ans;
    }
    return 0;
}